:: Note -- lines beginning with 2 colons are ignored in a BAT file -- works quicker than REM
:: Next line switches off echoing to screen
@ECHO OFF

:: Next line checks that there is at least 1 parameter 
if not "%1"=="" goto ok1
:badparm
echo ERROR: This batch file requires just 1 parameter: 
echo %%1= name of cmf file WITHOUT suffix 
:: Note, the double-% above prevents %1 being replaced with the first (probably blank) parameter
goto endbat

:ok1
:: Check that there is no 2nd parameter
if not "%2"=="" goto badparm

:: check that 1st parameter (+.cmf) names an existing file
if exist "%1.cmf" goto ok3
echo ERROR cannot locate file "%1.cmf"
goto endbat

:ok3  
echo Located input file "%1.cmf" OK

:: delete files which will be produced [maybe remaining from previous run]
del *.log 2>nul:
del "%1*.sum" 2>nul:
del "%1*.sl?" 2>nul:
del output.* 2>nul:
:: "2>nul:" prevents messages from being written to screen
:: in Windows jargon, standard unit 2 (error) is redirected to the standard device "nul:" (aka, the byte bucket) 

:: next line sets up a message to be displayed in case of error
:: to store the message we create an "environment variable" errmess
Set errmess=ERROR at first ADJUST stage
:: next line generates adjusted file %1.upd and summary file %1In.sum 
gemsim -cmf "%1.cmf" >"%1.log"
if errorlevel 1 goto err
echo Completed main sim
copy "%1.upd" output.har >nul:

Set errmess=ERROR at second ADJUST stage [output summary]
:: next line generates summary file output.sum from adjusted file output.har
gemsim -cmf postsum.cmf >postsum.log
if errorlevel 1 goto err
echo Completed PostSim summary  
copy output.sum "%1Out.sum" >nul:

Set errmess=ERROR at first DiffHAR stage [summary of percent changes]
:: next line puts % difference between old and new summary files into file percDiff.sum
:: note, original file is second parameter
diffhar "%1Out.sum" "%1In.sum" "%1PctDif.sum" P>PercDiff.log
if errorlevel 1 goto err
echo Completed Diffhar Percent changes 

Set errmess=ERROR at second DiffHAR stage [summary of ordinary changes]
:: next line puts ordinary difference between old and new summary files into file ordDiff.sum
:: note, original file is second parameter
diffhar "%1Out.sum" "%1In.sum" "%1OrdDif.sum" D >OrdDiff.log
if errorlevel 1 goto err
echo Completed Diffhar Ordinary changes 

echo COMPLETED WHOLE JOB -- following files were created:
dir/b/od %1*.* 
:: above, "/b" means "brief" display;  "/od" means in creation order
echo COMPLETED OK 
goto endbat

:err
:: to display the message stored in errmess, we must enclose it in % symbols
echo %errmess% 
echo ERROR: log list follows
dir/b/od *.log
echo ERROR in adjust.bat - examine most recent (ie, last) log listed above
pause press any key to continue  
:: if Ctrl-C is pressed, execution is terminated; if another key is pressed, execution continues
:endbat